<?php
//error_reporting(0);//Desactiva ver warnings, pero ojo puede haber errores...

/*Ejemplo
$contrato=1;
$documentId = '1qWIMknk4wvoq4pIRxJIclL_CbRks8-o4hbaB3n8tj-s';  //set your document ID here, eg. "j4i1m57GDYthXKqlGce9WKs4tpiFvzl1FXKmNRsTAAlH" y si te marca error haz el documento compartido para editar con todo el mundo, solo con el link
$template=array(
"{NOMBRE}"=>"Alejandro Castañon",
"{FECHA}"=> ("CDMX a ".date('d/m/Y', time())) ,
);
/**/

require_once(__DIR__.'/vendor/autoload.php');
$client = new \Google_Client();
$client->setApplicationName('Some name');  //this name doesn't matter
$client->setScopes([\Google_Service_Docs::DOCUMENTS]);
$client->setAccessType('offline');
$client->setAuthConfig(__DIR__.'/credentials.json');  //see https://www.youtube.com/watch?v=iTZyuszEkxI for how to create this file
$service = new \Google_Service_Docs($client);

/*esto solo prueba la conexion
$doc = $service->documents->get($documentId);
if(!$doc){echo "error conexion<br />";}else{/*echo "funciono conexion<br />";/**}
/**/

/*Versión final
replaceTemplate($template,true);//no puedes usarlo antes de la conexion
decargarPDF("https://docs.google.com/document/d/".$documentId."/export?format=pdf",'/home/sportmxcontratos/public_html/PDFs/'.$contrato.'-'.uniqid().'.pdf');
replaceTemplate($template,false);

/**versión previa
$nombre="Alejandro Castañon Diaz";
replaceText("{nombre}", $nombre, $documentId,$client,$service);
$pathtoPDF="https://docs.google.com/document/d/".$documentId."/export?format=pdf";
$storeLocation = '/home/sportmxcontratos/public_html/PDFs/'.$contrato.'-'.uniqid().'.pdf';
//echo $pathtoPDF."<br />".$storeLocation;
decargarPDF($pathtoPDF,$storeLocation);
replaceText($nombre, "{nombre}", $documentId,$client,$service);
/**/

//el search n replace
function replaceText($search, $replace,$documentId){
	//client y service ya se los pasas
    //$client = $this->getClient();
    //$service = new \Google_Service_Docs($client);
//    $documentId = $documentId; // Put your document ID here
	global $client, $service;//los jalas para search n replace, en vez de pasarlos como parametros
//	echo $documentId;echo " ID<br>";
//	echo $search." a ".$replace;echo "<br>";


    $replaceText = new \Google_Service_Docs_ReplaceAllTextRequest($client);


    $e = new \Google_Service_Docs_SubstringMatchCriteria();
    $e->text = "".$search."";
    $e->setMatchCase(false);


    $batchUpdateRequest = new \Google_Service_Docs_BatchUpdateDocumentRequest(array(
        'requests' => $replaceText
    ));

    $requests[] = new \Google_Service_Docs_Request(array(
        'replaceAllText' => array(
            'replaceText' => $replace,
            'containsText' => $e
        ),
    ));

    $batchUpdateRequest = new \Google_Service_Docs_BatchUpdateDocumentRequest(array(
        'requests' => $requests
    ));

    $response = $service->documents->batchUpdate($documentId, $batchUpdateRequest);
}
//la descarga de archivos
function descargarPDF($pathtoPDF,$storeLocation){//Export GDoc Template as PDF https://www.youtube.com/watch?v=_dcwuU3YNgM&ab_channel=Tesel truco 3
	
//$pathtoPDF="https://docs.google.com/document/d/1bcnvrUF079MPZsm-Yx-B0MLAFONbegpzto2w-c6boa8/export?format=pdf";
//$storeLocation = './mypdf'.time().'.pdf';
$elPDF=file_get_contents($pathtoPDF);
file_put_contents($storeLocation, $elPDF );
}

function descargarPDFenPlesk($pathtoPDF,$storeLocation){
    $domainId=4;// en la url ves el id del sitio https://romantic-payne.104-192-7-83.plesk.page:8443/smb/web/overview/id/4/type/domain
    $fileManager = new pm_FileManager($domainId);
    $file = $fileManager->fileGetContents($pathtoPDF);
    // do something with $contents
    $fileManager->filePutContents($storeLocation, $file);
}

//search n replace de array en ambos sentidos
function replaceTemplate($template,$direccion,$documentId){
//	echo $documentId;echo "<br>";
	$i=0; foreach( $template as $key=>$feach){  
		if($direccion == true){
			$search=$key;
			$replace=$feach;
		}else{
			$search=$feach;
			$replace=$key;			
		}
//		echo $search." to ".$replace;echo "<br>";
		replaceText($search, $replace,$documentId);
	$i++;}
}

//echo "si se incluyo...";


//Esto ya coordina el cambio
function Template1($contrato){

    $documentId = '1KTzJksNzI6ZFNkfMBXQTI25is49BYTTm1Dxjk4VCYXI';  //set your document ID here, eg. "j4i1m57GDYthXKqlGce9WKs4tpiFvzl1FXKmNRsTAAlH" y si te marca error haz el documento compartido para editar con todo el mundo, solo con el link

	$template=array(//algunas llaves llevan un poco de texto para al regresar el template no romperlo...
		"{FOLIO}"=>"MS".$row["id"],
		"{NOMBRE}"=>$row["nombre"],
		"{EMAIL}"=>$row["email"],
		"{TIPO}"=>$row["tipo"]." ,",
		"{RFC}"=>$row["rfc"],
		"{PRECIO}"=>"$".number_format($row["precio_con_iva"],2)." (".strtoupper(NumeroALetrasDinero($row["precio_con_iva"])).")",
		"{PAGO1}"=>"$".number_format($row["pago1"],2)." (".strtoupper(NumeroALetrasDinero($row["pago1"])).")",
		"{PAGO2}"=>"$".number_format($row["pago2"],2)." (".strtoupper(NumeroALetrasDinero($row["pago2"])).")",
		"{PAGO3}"=>"$".number_format($row["pago3"],2)." (".strtoupper(NumeroALetrasDinero($row["pago3"])).")",
		"{FECHA}"=> $row["fecha"] ,
		"{ASESOR}"=>$row["asesor"],
		//los no obligatorios	
		"{REPRESENTANTELEGAL}"=>$row["representante_legal"],
		"{NACIONALIDAD}"=>"nacionalidad ".$row["nacionalidad"],
		"{DOMICILIOCLIENTE}"=>$row["domicilio_cliente"],
		"{DOMICILIOINSTALACION}"=>$row["domicilio_instalacion"],
//		"{CIUDADCLIENTE}"=>$row["ciudad_cliente"],
//		"{ESTADOCLIENTE}"=>$row["estado_cliente"],
		"{NUMEROCOTIZACION}"=>"cotización ".$row["numero_cotizacion"],
		"{TIPOCANCHA}"=>"Tipo de cancha: ".$row["tipo_cancha"],
		"{METRAJETOTAL}"=>"Metraje total de pasto sintético: ".$row["metraje_total"],
		"{MODELODEPASTO}"=>"Modelo de pasto Sintético: ".$row["modelo_de_pasto"],
		"{ALTURAMM}"=>"Altura: ".$row["altura_mm"],
		"{GRAMAJEM2}"=>"Gramaje: ".$row["gramaje_m2"],
		"{NUMEROTRABAJADORES}"=>$row["numero_trabajadores"]." trabajadores",
    );
		
		$savePath='/home/sportmxcontratos/public_html/PDFs/'.$contrato.'-'.uniqid().'.pdf';
		//porque como tarda en ejecutarse la otra función truena el codigo, y si son funciones las pone en queue... por eso haces este update antes
		replaceTemplate($template,true,$documentId);//no puedes usarlo antes de la conexion, en la libreria (que ya esta arriba en librerias)
		decargarPDF("https://docs.google.com/document/d/".$documentId."/export?format=pdf",$savePath);
		replaceTemplate($template,false,$documentId);	
		
		//tarda tanto en ejecutarse que mejor el header lo hago en la funcion
		//PERO EN LA PRACTICA TAMPOCO FUNCIONA... TARDA MUCHO... ASI QUE MEJOR HAGO ECHO DE UN SCRIPT
		header("Location: .".$savepath);
		//return $saveUrl;
	
}